module Locomotive
  module Steam

    class ContentTypeFieldSelectOptionRepository

      include Models::Repository

      attr_accessor :content_type_field

      # Entity mapping
      mapping :content_type_field_select_options, entity: ContentTypeField::SelectOption do
        default_attribute :field, -> (repository) { repository.content_type_field }

        localized_attributes :name
      end

      def all
        query { order_by(position: :asc) }.all
      end

      def by_name(name)
        query { where(name: name) }.first
      end

      def by_id_or_name(id_or_name)
        find(id_or_name) || by_name(id_or_name)
      end

    end
  end
end
